%Dilosi sinartiseon me dynamika katigorimata
:-dynamic location/2.
:-dynamic movable/1.
:-dynamic final_location/2.
:-dynamic start_locations_OK/1.

%"Persons" pros metakinisi
movable(agrotis).
movable(lykos).
movable(katsika).
movable(xorto).

%Diathesimes pleures 
side(deksia).
side(aristera).

%
start_locations_OK(0).

%Arxiko minima pros ektuposi gia enimerosi tou paixti
:- nl,write('------------STARTING INFO------------'),nl,
   write('First you must put every "person"'),nl,
   write('at the side that you want.'),nl,
   write('Person: katsika, agrotis, lykos, xorto'),nl,
   write('Side: deksia, aristera'),nl,
   write('--------------FUNCTIONS--------------'),nl,
   write('start_location(X,Y):'),nl,
   write('   The X person goes to the Y side.'),nl,
   write('   This function is used only for'),nl,
   write('   initialization'),nl,nl,
   write('status:'),nl,
   write('   To see the current status'),nl,nl,
   write('move(X,Y):'),nl,
   write('   Move X "person" to Y side'),nl,
   write('quit:'),nl,
   write('   Quit'),nl,
   write('-------------------------------------'),nl.

%Des an to X einai person
is_movable(X):-           movable(X);
                          (write('----------------ERROR----------------'),nl,
                           write('This is not a "person"'),nl,
                           write('-------------------------------------'),nl,
                           !,fail).

%Des an to X einai side
is_side(X):-              side(X);
                          (write('----------------ERROR----------------'),nl,
                           write('This is not a side'),nl,
                           write('-------------------------------------'),nl,
                           !,fail).

%Elegxoume an o Z einai idi stin X pleula pou thelei na paei, kai an afti einai 
%apodekti pleura
other_side(X,Z):-         (side(X),location(Z,Y),\+X==Y);
                          (write('----------------ERROR----------------'),nl,
                           write('The side tha you had typed is not\napprovable'),nl,
                           write('-------------------------------------'),nl,
                           !,fail).

%Sinartisi gia to kathorismo arxikon katastaseon apo ton xristi.
%To X einai to person kai to Y i side tou.
start_location(X,Y):-     is_movable(X),!,
                          is_side(Y),!,
                          assert(location(X,Y)), other_side(Z,X), assert(final_location(X,Z)),
                          retract(movable(X)),!,fail.

%Elegxos gia to an i start locations einai apodektes
start_approvable:-        ((side(X),location(katsika,X),location(agrotis,X));
                            (side(Y),location(lykos,Y),location(agrotis,Y),side(W),
                              (\+location(katsika,W);\+location(xorto,W)));
                            (side(Z),location(lykos,Z),location(xorto,Z),side(A),
                              location(katsika,A),location(agrotis,A));
                            (side(B),location(xorto,B),location(agrotis,B),side(C),
                              (\+location(katsika,C);\+location(lykos,C))));
                          (write('----------------ERROR----------------'),nl,
                           write('Set start location again, because\nthere is conflict.'),nl,
                           write('-------------------------------------'),nl,
                           !,quit,fail).

%Apofugei ksemonaxiasmatos katsikas apo lyko.
approvable_lykos_katsika:-((location(lykos,aristera),location(katsika,deksia));
                          (location(lykos,deksia),location(katsika,aristera)));
                          (write('----------------ERROR----------------'),nl,
                           write('Lykos is going to kill katsika.'),nl,
                           write('-------------------------------------'),nl,
                           !,fail).

%Apofugi mastouromatos katsikas.
approvable_xorto_katsika:- ((location(katsika,aristera),location(xorto,deksia));
                           (location(katsika,deksia),location(xorto,aristera)));
                          (write('----------------ERROR----------------'),nl,
                           write('Katsika is going to smoke xorto.'),nl,
                           write('-------------------------------------'),nl,
                           !,fail).

%Elegxei an exoun mpei ola ta dedomena.
check:-                    ((location(agrotis,_),
                           location(katsika,_),
                           location(xorto,_),
                           location(lykos,_));
                           (write('----------------ERROR----------------'),nl,
                            write('You ve missed someone.\nSet a start location for everyone')
                            ,nl,write('-------------------------------------'),nl,
                            !,fail)),!,start_approvable,retract(start_locations_OK(0)),
                            assert(start_locations_OK(1)).

%Des an i varka einai stin pleura X. 
boat_location(Z):-	   (location(Z,Y),location(agrotis,X),X==Y);
                           (write('----------------ERROR----------------'),nl,
                            write('There is no boat in this side.'),nl,
                            write('-------------------------------------'),nl,
                            !,fail).

%Enimerosi neas katastasis. To Z einai to person kai to X to side sto opoio tha paei.
update(Z,X):-              retract(location(Z,_)),assert(location(Z,X)).

%Katharismos mnimis apo tis katastaseis pou exoume eisagei.
quit:-   retract(location(_,_)),retract(final_location(_,_)),fail.

%Sinartisi elegxou nikis!
win:-                      location(agrotis,X), final_location(agrotis,Y), X==Y,
                           location(katsika,Z), final_location(katsika,W), Z==W,
                           location(xorto,A), final_location(xorto,B), A=B,
                           location(lykos,C), final_location(lykos,D), C==D,
                           write('---------------CONGRATS--------------'),nl,
                           write('      You ve won tha game!!!'),nl,
                           write('-------------------------------------'),nl,
                           !,quit,fail.

%Oi move sinartiseis kounane to proto orisma (person) stin side X.

move(agrotis, X):-	   (start_locations_OK(1);check),!,
                           other_side(X,agrotis),!,
                           approvable_lykos_katsika,!,
                           approvable_xorto_katsika,!,
                           update(agrotis,X),
                           status,!,win,fail.

move(lykos,X):-            (start_locations_OK(1);check),!,
                           other_side(X,lykos),!,
                           boat_location(lykos),!,
                           approvable_xorto_katsika,!,
                           update(lykos,X),
                           update(agrotis,X),
                           status,!,win,fail.

move(katsika,X):-	   (start_locations_OK(1);check),!,
                           other_side(X,katsika),!,
                           boat_location(katsika),!,
                           update(katsika,X),
			   update(agrotis,X),
                           status,!, win, fail.

move(xorto,X):-            (start_locations_OK(1);check),!,
                           other_side(X,xorto),!,
                           boat_location(xorto),!,
                           approvable_lykos_katsika,!,
                           update(xorto,X),
                           update(agrotis,X),
                           status,!, win, fail.

%Emfanisi katastaseon
status:- write('---------------STATUS----------------'),nl,
         write('PERSON\t\tPOSITION'),nl,
         location(X,Y),write(X),write('\t\t'),write(Y),nl,fail;
         write('-------------------------------------'),nl.

